//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//+++++     _________            __           __________       __               __    __  __    _________       +++++//
//+++++    |XX|X X XX|           XX          |HH|HHH\HHH\     |XX              |XX|  |XX||XX|  |XX|X X XX|      +++++//
//+++++    |XX|    |XX|         /XX\         |HH|      \HH\   |XX||XX|     |XX||XX|    |XX|    |XX|    |XX|     +++++//
//+++++    |XX|    |XX|        /XXXX\        |HH|       |HH|  |XX| |XX|   |XX| |XX|    |XX|    |XX|    |XX|     +++++//
//+++++    |XX|   |XX|        /XX/\XX\       |HH|       |HH|  |XX|  |XX| |XX|  |XX|    |XX|    |XX|   |XX|      +++++//
//+++++    |XX|X X X|        /XX/  \XX\      |HH|       |HH|  |XX|     |XX|    |XX|    |XX|    |XX|X X X|       +++++//
//+++++    |XX|  \XX\       /XXXXXXXXXX\     |HH|       |HH|  |XX|             |XX|    |XX|    |XX|   \XX\      +++++//
//+++++    |XX|   \XX\     /XX/      \XX\    |HH|      /HH/   |XX|             |XX|    |XX|    |XX|    \XX\     +++++//
//+++++    |XX|    |XX|   /XX/        \XX\   |HH|    /HHH/    |XX|             |XX|    |XX|    |XX|     |XX|    +++++//
//+++++    |XX|    |XX|  /XX/          \XX\  |HHHHHHHHH/      |XX|             |XX|  |XX||XX|  |XX|     |XX|    +++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//++++++++++++++++++++++++++++++++     Создатель графики Максим Дубинов(Makarus)     ++++++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++     По всем вопросам писать сюда vk.com/id178972344     +++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//

texture gTexture;
texture mask;
#include "mta-helper.fx"

float Contrast = 0.9; // регулирует переход цвета к белому (меньше) и жёлтому (значение больше)
float Saturate = 1.0; 
float Brightness = 1.0; // регулирует начало захвата блумом участка. Чем меньше показатель - тем более серый элемент будет считать включённым

////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// RADMIR ////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

sampler gTex = sampler_state
{
    Texture = <gTexture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU  = Clamp;
	AddressV  = Clamp;
	SRGBTexture=FALSE;
	MaxMipLevel=0;
	MipMapLodBias=0;	
};
struct VSInput
{
    float3 Position : POSITION0;
    float3 Normal : NORMAL0;
    float4 Diffuse : COLOR0;
    float2 TexCoord : TEXCOORD0;
};
struct PSInput
{
    float4 Position : POSITION0;
    float4 Diffuse : COLOR0;
    float2 TexCoord : TEXCOORD0;
    float4 Projection : TEXCOORD1;
    float Depth : TEXCOORD2;
};

sampler gMask = sampler_state
{
    Texture = (mask);
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU  = Clamp;
	AddressV  = Clamp;
	SRGBTexture=FALSE;
	MaxMipLevel=0;
	MipMapLodBias=0;	
};

////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// RADMIR ////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

PSInput VerShader(VSInput VS)
{
	PSInput PS = (PSInput)0;
    PS.Position = mul(float4(VS.Position, 1), gWorldViewProjection);
    PS.TexCoord = VS.TexCoord;
    return PS;
}

float Luminance(in float3 color)
{
	return dot(color.rgb, float3(0.2125f, 0.7154f, 0.0721f));
}

float dithering(float2 vpos, int l)
{
	float res = 0.0;
	for(float i = 1-l; i<= 0; i++)
	{
		float Size = exp2(i);
	    float2 coord = floor(vpos*Size) % 2.0;
		float cd = 2.0*coord.x - 4.0*coord.x*coord.y + 3.0*coord.y;
		res += exp2(2.0*(i+l))* cd;
	}
	float res1 = 4.0*exp2(2.0 * l)- 4.0;
	return res/res1 + 1.0/exp2(2.0 * l);
}

////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// RADMIR ////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

float4 JustColor(PSInput PS, float2 vPos : VPOS0) : COLOR0
{     
    float4 sourceColor = tex2D(gTex, PS.TexCoord);
    float4 maskx = tex2D(gMask, PS.TexCoord);
    float4 bloom = 0.0;	
	float2 uv;	

	float2 screenfact = 0.0001;		   
	float step = (1.0-0.5)*1.2;		   
	screenfact.xy*= step;

    float d3 = dithering(vPos.xy, 1.0); 	
	
	float2 dir;
	sincos(d3*42.528, dir.x, dir.y);

	  [fastopt]		
      for (int dx=0; dx<24; dx++)
      { 	
		uv = dir.xy * (dx+1.0);
		dir.xy = mul(dir.xy, float2x2(0.76465, -0.64444, 0.64444, 0.76465));				   		   
		uv/= 0.5;

		uv*= 5.0;
		uv.xy =(uv.xy*screenfact.xy)+PS.TexCoord.xy;
		float4 bloom1 = tex2D(gMask, uv.xy);
			
		float4 bloom2 = tex2D(gTex, uv.xy);
               bloom2.rgb = pow(bloom2.rgb*Brightness, Contrast);
               bloom2.rgb = lerp(bloom2.rgb, Luminance(bloom2.rgb), 1.0 - Saturate);
               bloom2.rgb = saturate(bloom2.rgb);	
			   
		bloom+= bloom1*bloom2; //bloom1*

	  }
           sourceColor.rgb = bloom.rgb/24;			   	   
    return sourceColor;
}

////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// RADMIR ////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

technique tec0
{
    pass P0
    {
        PixelShader = compile ps_3_0 JustColor();
        VertexShader = compile vs_3_0 VerShader();
    }
}